Neptune API V2 Python API library
Neptune API V2 Python API library
The Neptune API V2 Python library provides convenient access to the Neptune API V2 REST API from any Python 3.9+ application. The library includes type definitions for all request params and response fields, and offers both synchronous and asynchronous clients powered by httpx.
It is generated with Stainless.
Documentation
The full API of this library can be found in api.md.
Installation
# install from PyPI
pip install neptune_api_v2
Usage
The full API of this library can be found in api.md.
from neptune_api_v2 import NeptuneAPIV2
client = NeptuneAPIV2()
response = client.markets.get_overview(
with_text=True,
with_value=True,
)
print(response.data)
Async usage
Simply import AsyncNeptuneAPIV2 instead of NeptuneAPIV2 and use await with each API call:
import asyncio
from neptune_api_v2 import AsyncNeptuneAPIV2
client = AsyncNeptuneAPIV2()
async def main() -> None:
response = await client.markets.get_overview(
with_text=True,
with_value=True,
)
print(response.data)
asyncio.run(main())
Functionality between the synchronous and asynchronous clients is otherwise identical.
With aiohttp
By default, the async client uses httpx for HTTP requests. However, for improved concurrency performance you may also use aiohttp as the HTTP backend.
You can enable this by installing aiohttp:
# install from PyPI
pip install neptune_api_v2[aiohttp]
Then you can enable it by instantiating the client with http_client=DefaultAioHttpClient():
import asyncio
from neptune_api_v2 import DefaultAioHttpClient
from neptune_api_v2 import AsyncNeptuneAPIV2
async def main() -> None:
async with AsyncNeptuneAPIV2(
http_client=DefaultAioHttpClient(),
) as client:
response = await client.markets.get_overview(
with_text=True,
with_value=True,
)
print(response.data)
asyncio.run(main())
Using types
Nested request parameters are TypedDicts. Responses are Pydantic models which also provide helper methods for things like:
- Serializing back into JSON,
model.to_json() - Converting to a dictionary,
model.to_dict()
Typed requests and responses provide autocomplete and documentation within your editor. If you would like to see type errors in VS Code to help catch bugs earlier, set python.analysis.typeCheckingMode to basic.
Pagination
List methods in the Neptune API V2 API are paginated.
This library provides auto-paginating iterators with each list response, so you do not have to request successive pages manually:
from neptune_api_v2 import NeptuneAPIV2
client = NeptuneAPIV2()
all_users = []
# Automatically fetches more pages as needed.
for user in client.user.get_tx_history(
address="injvalcons1a03k0ztfyjnd70apawva003pkh0adqmau0a9q0",
):
# Do something with user here
all_users.append(user)
print(all_users)
Or, asynchronously:
import asyncio
from neptune_api_v2 import AsyncNeptuneAPIV2
client = AsyncNeptuneAPIV2()
async def main() -> None:
all_users = []
# Iterate through items across all pages, issuing requests as needed.
async for user in client.user.get_tx_history(
address="injvalcons1a03k0ztfyjnd70apawva003pkh0adqmau0a9q0",
):
all_users.append(user)
print(all_users)
asyncio.run(main())
Alternatively, you can use the .has_next_page(), .next_page_info(), or .get_next_page() methods for more granular control working with pages:
first_page = await client.user.get_tx_history(
address="injvalcons1a03k0ztfyjnd70apawva003pkh0adqmau0a9q0",
)
if first_page.has_next_page():
print(f"will fetch next page using these details: {first_page.next_page_info()}")
next_page = await first_page.get_next_page()
print(f"number of items we just fetched: {len(next_page.data)}")
# Remove `await` for non-async usage.
Or just work directly with the returned data:
first_page = await client.user.get_tx_history(
address="injvalcons1a03k0ztfyjnd70apawva003pkh0adqmau0a9q0",
)
print(f"next page cursor: {first_page.prev_event_uuid}") # => "next page cursor: ..."
for user in first_page.data:
print(user.event_uuid)
# Remove `await` for non-async usage.
Handling errors
When the library is unable to connect to the API (for example, due to network connection problems or a timeout), a subclass of neptune_api_v2.APIConnectionError is raised.
When the API returns a non-success status code (that is, 4xx or 5xx
response), a subclass of neptune_api_v2.APIStatusError is raised, containing status_code and response properties.
All errors inherit from neptune_api_v2.APIError.
import neptune_api_v2
from neptune_api_v2 import NeptuneAPIV2
client = NeptuneAPIV2()
try:
client.markets.get_overview()
except neptune_api_v2.APIConnectionError as e:
print("The server could not be reached")
print(e.__cause__) # an underlying Exception, likely raised within httpx.
except neptune_api_v2.RateLimitError as e:
print("A 429 status code was received; we should back off a bit.")
except neptune_api_v2.APIStatusError as e:
print("Another non-200-range status code was received")
print(e.status_code)
print(e.response)
Error codes are as follows:
| Status Code | Error Type |
|---|---|
| 400 | BadRequestError |
| 401 | AuthenticationError |
| 403 | PermissionDeniedError |
| 404 | NotFoundError |
| 422 | UnprocessableEntityError |
| 429 | RateLimitError |
| >=500 | InternalServerError |
| N/A | APIConnectionError |
Retries
Certain errors are automatically retried 2 times by default, with a short exponential backoff. Connection errors (for example, due to a network connectivity problem), 408 Request Timeout, 409 Conflict, 429 Rate Limit, and >=500 Internal errors are all retried by default.
You can use the max_retries option to configure or disable retry settings:
from neptune_api_v2 import NeptuneAPIV2
# Configure the default for all requests:
client = NeptuneAPIV2(
# default is 2
max_retries=0,
)
# Or, configure per-request:
client.with_options(max_retries = 5).markets.get_overview()
Timeouts
By default requests time out after 1 minute. You can configure this with a timeout option,
which accepts a float or an httpx.Timeout object:
from neptune_api_v2 import NeptuneAPIV2
# Configure the default for all requests:
client = NeptuneAPIV2(
# 20 seconds (default is 1 minute)
timeout=20.0,
)
# More granular control:
client = NeptuneAPIV2(
timeout=httpx.Timeout(60.0, read=5.0, write=10.0, connect=2.0),
)
# Override per-request:
client.with_options(timeout = 5.0).markets.get_overview()
On timeout, an APITimeoutError is thrown.
Note that requests that time out are retried twice by default.
Advanced
Logging
We use the standard library logging module.
You can enable logging by setting the environment variable NEPTUNE_API_V2_LOG to info.
$ export NEPTUNE_API_V2_LOG=info
Or to debug for more verbose logging.
How to tell whether None means null or missing
In an API response, a field may be explicitly null, or missing entirely; in either case, its value is None in this library. You can differentiate the two cases with .model_fields_set:
if response.my_field is None:
if 'my_field' not in response.model_fields_set:
print('Got json like {}, without a "my_field" key present at all.')
else:
print('Got json like {"my_field": null}.')
Accessing raw response data (e.g. headers)
The “raw” Response object can be accessed by prefixing .with_raw_response. to any HTTP method call, e.g.,
from neptune_api_v2 import NeptuneAPIV2
client = NeptuneAPIV2()
response = client.markets.with_raw_response.get_overview()
print(response.headers.get('X-My-Header'))
market = response.parse() # get the object that `markets.get_overview()` would have returned
print(market.data)
These methods return an APIResponse object.
The async client returns an AsyncAPIResponse with the same structure, the only difference being awaitable methods for reading the response content.
.with_streaming_response
The above interface eagerly reads the full response body when you make the request, which may not always be what you want.
To stream the response body, use .with_streaming_response instead, which requires a context manager and only reads the response body once you call .read(), .text(), .json(), .iter_bytes(), .iter_text(), .iter_lines() or .parse(). In the async client, these are async methods.
with client.markets.with_streaming_response.get_overview() as response :
print(response.headers.get('X-My-Header'))
for line in response.iter_lines():
print(line)
The context manager is required so that the response will reliably be closed.
Making custom/undocumented requests
This library is typed for convenient access to the documented API.
If you need to access undocumented endpoints, params, or response properties, the library can still be used.
Undocumented endpoints
To make requests to undocumented endpoints, you can make requests using client.get, client.post, and other
http verbs. Options on the client will be respected (such as retries) when making this request.
import httpx
response = client.post(
"/foo",
cast_to=httpx.Response,
body={"my_param": True},
)
print(response.headers.get("x-foo"))
Undocumented request params
If you want to explicitly send an extra param, you can do so with the extra_query, extra_body, and extra_headers request
options.
Undocumented response properties
To access undocumented response properties, you can access the extra fields like response.unknown_prop. You
can also get all the extra fields on the Pydantic model as a dict with
response.model_extra.
Configuring the HTTP client
You can directly override the httpx client to customize it for your use case, including:
- Support for proxies
- Custom transports
- Additional advanced functionality
import httpx
from neptune_api_v2 import NeptuneAPIV2, DefaultHttpxClient
client = NeptuneAPIV2(
# Or use the `NEPTUNE_API_V2_BASE_URL` env var
base_url="http://my.test.server.example.com:8083",
http_client=DefaultHttpxClient(proxy="http://my.test.proxy.example.com", transport=httpx.HTTPTransport(local_address="0.0.0.0")),
)
You can also customize the client on a per-request basis by using with_options():
client.with_options(http_client=DefaultHttpxClient(...))
Managing HTTP resources
By default the library closes underlying HTTP connections whenever the client is garbage collected. You can manually close the client using the .close() method if desired, or with a context manager that closes when exiting.
from neptune_api_v2 import NeptuneAPIV2
with NeptuneAPIV2() as client:
# make requests here
...
# HTTP client is now closed
Versioning
This package generally follows SemVer conventions, though certain backwards-incompatible changes may be released as minor versions:
- Changes that only affect static types, without breaking runtime behavior.
- Changes to library internals which are technically public but not intended or documented for external use. (Please open a GitHub issue to let us know if you are relying on such internals.)
- Changes that we do not expect to impact the vast majority of users in practice.
We take backwards-compatibility seriously and work hard to ensure you can rely on a smooth upgrade experience.
We are keen for your feedback; please open an issue with questions, bugs, or suggestions.
Determining the installed version
If you’ve upgraded to the latest version but aren’t seeing any new features you were expecting then your python environment is likely still using an older version.
You can determine the version that is being used at runtime with:
import neptune_api_v2
print(neptune_api_v2.__version__)
Requirements
Python 3.9 or higher.